#include <stdio.h>

struct aligner { char c; void* a; };

int main(int argc, char** argv)
{
  printf("#ifndef js_cpucfg2___\n");
  printf("#define js_cpucfg2___\n");
  int bpw = sizeof(void*);
  printf("#define JS_BYTES_PER_WORD %d\n",bpw);

  int sow = sizeof(double);
  printf("#define JS_BYTES_PER_DOUBLE %d\n",sow);

  if (bpw == 4)
  printf("#define JS_BITS_PER_WORD_LOG2 5\n");
  else if (bpw == 8)
  printf("#define JS_BITS_PER_WORD_LOG2 6\n");

  aligner al;
  int aop = (char*)(void*)(&al.a) - (char*)(void*)(&al.c);
  printf("#define JS_ALIGN_OF_POINTER %d\n",aop);

  printf("#ifdef _MSC_VER\n");
  printf("#define JS_HAVE___INTN 1\n");
  printf("#define JS_STDDEF_H_HAS_INTPTR_T 1\n");
  printf("#endif\n");
  printf("#endif\n");
}

/*
jscpucfg.h

32-bit
#define IS_LITTLE_ENDIAN 1
#undef  IS_BIG_ENDIAN
#define JS_BYTES_PER_DOUBLE 8L
#define JS_BYTES_PER_WORD   4L
#define JS_BITS_PER_WORD_LOG2   5
#define JS_ALIGN_OF_POINTER 4L

64-bit
#define JS_BYTES_PER_WORD   8L
#define JS_BITS_PER_WORD_LOG2   6
#define JS_ALIGN_OF_POINTER 8L

stdint.h
typedef signed char int8_t;
typedef unsigned char   uint8_t;
typedef short  int16_t;
typedef unsigned short  uint16_t;
typedef int  int32_t;
typedef unsigned   uint32_t;
typedef long long  int64_t;
typedef unsigned long long   uint64_t;
*/
